package com.dsic.gj_erp.controller.jhgk;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.pc.*;
import com.dsic.gj_erp.pc.service.三月滚动接口;
import com.dsic.gj_erp.pc.service.工序CD接口;
import com.dsic.gj_erp.pc.service.订货计划滚动信息接口;
import com.dsic.gj_erp.pc.service.设备产能接口;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.util.*;
import java.util.concurrent.Semaphore;
import java.util.stream.Collectors;

@RestController
@RequestMapping("sygdpc")
@AllArgsConstructor
public class 三月滚动排产控制器 {

    private final 三月滚动接口 _三月滚动接口;
    private final 设备产能接口 _设备产能接口;
    private final 工序CD接口 _工序CD接口;
    private final 订货计划滚动信息接口 _订货计划滚动信息接口;

    private static Semaphore semaphore = new Semaphore(1);

    @GetMapping("createSygdjh")
    public ResultBean<?> 生成三月滚动(String from, String to){
        try {
            semaphore.acquire();
            return _三月滚动接口.生成三月滚动(from,to);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        } finally {
            semaphore.release();
        }
    }

    @GetMapping("pc")
    public ResultBean<?> pc(String from, String to){
        try {
            semaphore.acquire();
            排产.execute(from,to);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        } catch (RuntimeException e) {
            e.printStackTrace();
            ResultBean<?> resultBean = new ResultBean<>();
            resultBean.setStatus(10000);
            resultBean.setSuccess(false);
            resultBean.setMessage(e.getMessage());
            return resultBean;
        } finally {
            semaphore.release();
        }
        return new ResultBean<>();
    }

    @GetMapping("sygdjh")
    public ResultBean<?> 获取三月滚动计划(String from, String to) throws InterruptedException {
        semaphore.acquire();
        if (!StrUtil.isAllNotEmpty(from,to)){
            semaphore.release();
            return new ResultBean<>();
        }

        HashMap<Object, Object> map = new HashMap<>();
        if (from.equals(Manager.from)&&to.equals(Manager.to)){
            semaphore.release();
            map.put("zy",Manager.资源池);
            return new ResultBean<>(map);
        }

        try {
            排产.execute(from,to);
        }finally {
            semaphore.release();
        }
        map.put("zy",Manager.资源池);
        return new ResultBean<>(map);
    }

    @GetMapping("getDhjhAll")
    public ResultBean<?> 获取全部订货计划(){
        Object o = _订货计划滚动信息接口.get();
        return new ResultBean<>(o);
    }

    @PostMapping("saveDhjh")
    public ResultBean<?> 设置订货计划(@RequestBody List<订货计划> _订货计划){
        for (订货计划 订货计划 : _订货计划) {
            _订货计划滚动信息接口.save(订货计划);
        }
        return new ResultBean<>();
    }
    @PostMapping("removeDhjh")
    public ResultBean<?> 删除订货计划(@RequestBody List<订货计划> _订货计划){
        for (订货计划 订货计划 : _订货计划) {
            _订货计划滚动信息接口.remove(订货计划.getKey());
        }
        return new ResultBean<>();
    }

    @GetMapping("getCdAll")
    public ResultBean<?> 获取全部工序CD(){
        Object o = _工序CD接口.get();
        return new ResultBean<>(o);
    }

    @PostMapping("saveGxcd")
    public ResultBean<?> 设置工序CD(@RequestBody List<工序CD> _工序CD){
        for (工序CD 工序CD : _工序CD) {
            _工序CD接口.save(工序CD);
        }
        return new ResultBean<>();
    }

    @PostMapping("removeGxcd")
    public ResultBean<?> 删除工序CD(@RequestBody List<工序CD> _工序CD){
        for (工序CD 工序CD : _工序CD) {
            _工序CD接口.remove(工序CD.getGx().name());
        }
        return new ResultBean<>();
    }
    @GetMapping("getSbcnAll")
    public ResultBean<?> 获取全部产能(){
        Object o = _设备产能接口.get();
        return new ResultBean<>(o);
    }

    @PostMapping("saveSbcn")
    public ResultBean<?> 设置产能(@RequestBody List<设备产能> _设备产能){
        for (设备产能 设备产能 : _设备产能) {
            _设备产能接口.save(设备产能);
        }
        return new ResultBean<>();
    }

    @PostMapping("removeSbcn")
    public ResultBean<?> 删除产能(@RequestBody List<设备产能> _设备产能){
        for (设备产能 设备产能 : _设备产能) {
            _设备产能接口.remove(设备产能.getCode());
        }
        return new ResultBean<>();
    }

//    工序list
        @GetMapping("getGxDict")
        public ResultBean<?> getGxDict(){
            Constant.工序[] l= Constant.工序.values();
//            List<Map> list=new ArrayList<>();
//            for (Constant.工序 工序 : l) {
//                String code=工序.getCode();
//                String name=工序.name();
//                Map<String,String> map=new HashMap<>();
//                map.put(name,code);
//                list.add(map);
//            }

            List<JSONObject> list = Arrays.stream(l).filter(o->StrUtil.isNotEmpty(o.name())&&!o.name().equals("NULL"))
                    .map(item -> new JSONObject(new LinkedHashMap<>())
                            .fluentPut("name", item.name())
                            .fluentPut("code", item.getCode())
                    )
                    .collect(Collectors.toList());
            return new ResultBean<>(list);
        }


}
