package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmYdjhLj;
import com.dsic.gj_erp.bean.pgd.PgdDmjh;
import com.dsic.gj_erp.bean.pgd.PgdDmjh;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.jhgk.DmYdjhLjService;
import com.dsic.gj_erp.service.pgd.PgdDmjhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdDmjh")
public class PgdDmjhController {
    
    
    @Autowired
    PgdDmjhService pgdDmjhService;

    @Autowired
    DmYdjhLjService dmYdjhLjService;



    @PostMapping("/getDmPgd")
    @ResponseBody
    public ResultBean getDmPgd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        QueryWrapper<DmYdjhLj> qw =new QueryWrapper<>();


        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"czbh",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"pl",(String)map.get("pl"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("fd")),"fd",(String)map.get("fd"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("zt")),"dm_zt",(String)map.get("zt"));

        qw.eq("dmbs","Y");
        qw.orderBy(true,true,"czbh","pl","fd");
        return new ResultBean(dmYdjhLjService.list(qw));

    }

    @PostMapping("/saveDmPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean saveDmPgdXd(HttpServletRequest req, @RequestBody List<DmYdjhLj> list) throws Exception, CustomException {
        pgdDmjhService.saveDmPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveDmPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveDmPgdXdBack(HttpServletRequest req, @RequestBody List<DmYdjhLj>list) throws Exception, CustomException {
        pgdDmjhService.saveDmPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/saveDmPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveDmPgdFk(HttpServletRequest req, @RequestBody List<DmYdjhLj>list) throws Exception, CustomException {
        pgdDmjhService.saveDmPgdFk(list,req);
        return new ResultBean();
    }
    @PostMapping("/saveDmFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveDmFk(HttpServletRequest req, @RequestBody List<DmYdjhLj>list) throws Exception, CustomException {
        pgdDmjhService.saveDmFk(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveDmPgdJs")
    @ResponseBody
    @AuthFunction
    public ResultBean saveDmPgdJs(HttpServletRequest req, @RequestBody List<DmYdjhLj>list) throws Exception, CustomException {
        pgdDmjhService.saveDmPgdJs(list,req);
        return new ResultBean();
    }

}

